/*
 *   Copyright (C) 2009,2010 by Jonathan Naylor G4KLX
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef	AnalogueRepeaterConfigFrame_H
#define	AnalogueRepeaterConfigFrame_H

#include "AnalogueRepeaterConfigControllerSet.h"
#include "AnalogueRepeaterConfigCallsignSet.h"
#include "AnalogueRepeaterConfigExternalSet.h"
#include "AnalogueRepeaterConfigRadioSet.h"
#include "AnalogueRepeaterConfigDTMF1Set.h"
#include "AnalogueRepeaterConfigDTMF2Set.h"
#include "AnalogueRepeaterConfigTonesSet.h"
#include "AnalogueRepeaterConfigTimesSet.h"
#include "AnalogueRepeaterConfigFeelSet.h"
#include "AnalogueRepeaterConfigAckSet.h"
#include "AnalogueRepeaterConfigDefs.h"
#include "AnalogueDefines.h"
#include "ActiveHangSet.h"

#include <wx/wx.h>

class CAnalogueRepeaterConfigFrame : public wxFrame {
public:
	CAnalogueRepeaterConfigFrame(const wxString& title = wxEmptyString);
	virtual ~CAnalogueRepeaterConfigFrame();

	virtual void onQuit(wxCommandEvent& event);
	virtual void onAbout(wxCommandEvent& event);
	virtual void onClose(wxCloseEvent& event);

private:
	CAnalogueRepeaterConfigCallsignSet*    m_callsign;
	CAnalogueRepeaterConfigAckSet*         m_ack;
	CAnalogueRepeaterConfigTimesSet*       m_times;
	CAnalogueRepeaterConfigTonesSet*       m_tones;
	CAnalogueRepeaterConfigFeelSet*        m_feel;
	CAnalogueRepeaterConfigRadioSet*       m_radio;
	CAnalogueRepeaterConfigExternalSet*    m_external;
	CAnalogueRepeaterConfigControllerSet*  m_controller;
	CAnalogueRepeaterConfigDTMF1Set*       m_dtmf1;
	CAnalogueRepeaterConfigDTMF2Set*       m_dtmf2;
	CActiveHangSet*                        m_active;

	DECLARE_EVENT_TABLE()

	wxMenuBar* createMenuBar();
	void saveConfig();
};

#endif
